package info.bukova.isspst.data;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.springframework.security.core.GrantedAuthority;

@Entity
@Table(name="ROLE")
public class Role implements GrantedAuthority, DataModel {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 5677876140880991163L;
	
	@Id
	@Column(name="ID")
    @GeneratedValue
	private int id;
	@Column(name="AUTHORITY", unique=true)
	private String authority;
	@Column(name="DESCRIPTION")
	private String description;
	@Column(name="CREATED")
	private Date created;
	@Column(name="MODIFIED")
	private Date modified;
	@Transient
	private boolean valid;
	
	public Role(String authority, String description) {
		this.authority = authority;
		this.description = description;
	}
	
	public Role() {
		
	}

	@Override
	public String getAuthority() {
		return authority;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public void setAuthority(String authority) {
		this.authority = authority;
	}

	public Date getCreated() {
		return created;
	}

	public void setCreated(Date created) {
		this.created = created;
	}

	public Date getModified() {
		return modified;
	}

	public void setModified(Date modified) {
		this.modified = modified;
	}

	public boolean isValid() {
		return valid;
	}

	public void setValid(boolean valid) {
		this.valid = valid;
	}
	
	@Override
	public boolean equals(Object o) {
		if ((o instanceof Role) && ((Role)o).getId() == this.id) {
			return true;
		} else {
			return false;
		}
	}

}
