package info.bukova.isspst.filters;

import info.bukova.isspst.data.User;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.TypeSafeMatcher;

import static info.bukova.isspst.StringUtils.nullStr;

public class UserFilter implements Filter<User> {
	
	private User condUser;
	
	public UserFilter(User condition) {
		this.condUser = condition;
	}
	
	private static class UserMatcher extends TypeSafeMatcher<User> {

		private User condUser;
		
		public UserMatcher(User condition) {
			this.condUser = condition;
		}
		
		@Override
		public void describeTo(Description description) {
			description.appendText("user matcher");
		}

		@Override
		public boolean matchesSafely(User item) {
			return nullStr(item.getUsername()).toLowerCase().contains(nullStr(condUser.getUsername()).toLowerCase())
					&& nullStr(item.getFirstName()).toLowerCase().contains(nullStr(condUser.getFirstName()).toLowerCase())
					&& nullStr(item.getLastName()).toLowerCase().contains(nullStr(condUser.getLastName()).toLowerCase())
					&& nullStr(item.getPersonalNumber()).toLowerCase().contains(nullStr(condUser.getPersonalNumber()).toLowerCase());
		}
		
		@Factory
		public UserMatcher matchUser(User cond) {
			return new UserMatcher(cond);
		}
		
	}

	@Override
	public TypeSafeMatcher<User> matcher() {
		return new UserMatcher(condUser);
	}

	@Override
	public String queryString() {
		return null;
	}

}
